(function ($) {

    if ('undefined' !== typeof (wp) && 'undefined' !== typeof (wp.customize)) {


        (function (api) {
            api.panel('clp_panel', function (panel) {
                var loginURL = CLPUrl.siteurl + '?clp-customize=true';
                // console.log(panel)
                panel.expanded.bind(function (isExpanded) {
                    if (isExpanded) {
                        wp.customize.previewer.previewUrl.set(loginURL);
                    } else {
                        wp.customize.previewer.previewUrl.set(CLPUrl.siteurl);
                    }
                });
            });
        }(wp.customize));

        wp.customize.controlConstructor['clp-layout'] = wp.customize.Control.extend({
            ready: function () {
                var control = this;

                this.container.on('change', 'input:radio', function () {
                    var template = $(this).val();

                    control.loadTemplate('default');

                    if ('default' !== template) {
                        control.loadTemplate(template);
                    }

                });
            },
            loadTemplate: function (optionName) {
                var control = this,
                    options = control.params.options[optionName];

                $.each(options, function (index, option) {
                    var currentControl = wp.customize.control(option.name);

                    currentControl.setting(option.value);

                    if (currentControl.id === "clp_logo-google_fonts") {
                        var family = JSON.parse(option.value);
                        $('#customize-control-clp_logo-google_fonts .clp-font-family-select').val(family.family).change();
                        $('#customize-control-clp_logo-google_fonts .clp-font-variant-select').val(family.selected.variant).change();
                    }

                    if (currentControl.id === "clp_form_typography-google_fonts") {
                        var family = JSON.parse(option.value);
                        $('#customize-control-clp_form_typography-google_fonts .clp-font-family-select').val(family.family).change();
                        $('#customize-control-clp_form_typography-google_fonts .clp-font-variant-select').val(family.selected.variant).change();
                    }

                    if (currentControl.params.type === 'alpha-color') {
                        $(currentControl.selector + ' input').change();
                    }

                });
            }
        });

        wp.customize.bind('ready', function () {

            wp.customize.previewer.bind('clp-focus-section', function (section) {

                if (wp.customize.section(section)) {
                    wp.customize.section(section).focus();
                }
            });

            wp.customize('clp_logo', function (value) {
                value.bind(function (to) {
                    var logoText = wp.customize.control('clp_logo-text'),
                        logoTextFontSize = wp.customize.control('clp_logo-text-font_size'),
                        logoTextLetterSpacing = wp.customize.control('clp_logo-text-letter_spacing'),
                        logoTypographySep = wp.customize.control('clp_logo-typography-separator'),
                        logoTypography = wp.customize.control('clp_logo-google_fonts'),
                        logoTextColor = wp.customize.control('clp_logo-text-color'),
                        logoImage = wp.customize.control('clp_logo-image'),
                        logoImageWidth = wp.customize.control('clp_logo-image-width'),
                        logoUrl = wp.customize.control('clp_logo-url'),
                        logoSpacingTop = wp.customize.control('clp_logo-spacing-top'),
                        logoSpacingBottom = wp.customize.control('clp_logo-spacing-bottom'),
                        logoSeparator = wp.customize.control('clp_logo-settings-separator'),
                        logoContained = wp.customize.control('clp_logo-contained');


                    switch (to) {
                        case 'none':
                            logoText.toggle(false);
                            logoTextFontSize.toggle(false);
                            logoTextLetterSpacing.toggle(false);
                            logoTypographySep.toggle(false);
                            logoTypography.toggle(false);
                            logoTextColor.toggle(false);
                            logoImage.toggle(false);
                            logoImageWidth.toggle(false);
                            logoUrl.toggle(false);
                            logoSpacingTop.toggle(false);
                            logoSpacingBottom.toggle(false);
                            logoSeparator.toggle(false);
                            logoContained.toggle(false);
                            break;

                        case 'text':
                            logoText.toggle(true);
                            logoTextFontSize.toggle(true);
                            logoTextLetterSpacing.toggle(true);
                            logoTypographySep.toggle(true);
                            logoTypography.toggle(true);
                            logoTextColor.toggle(true);
                            logoImage.toggle(false);
                            logoImageWidth.toggle(false);
                            logoUrl.toggle(true);
                            logoSpacingTop.toggle(true);
                            logoSpacingBottom.toggle(true);
                            logoSeparator.toggle(true);
                            logoContained.toggle(true);
                            break;

                        case 'image':
                            logoText.toggle(false);
                            logoTextFontSize.toggle(false);
                            logoTextLetterSpacing.toggle(false);
                            logoTypographySep.toggle(false);
                            logoTypography.toggle(false);
                            logoTextColor.toggle(false);
                            logoImage.toggle(true);
                            logoImageWidth.toggle(true);
                            logoUrl.toggle(true);
                            logoSpacingTop.toggle(true);
                            logoSpacingBottom.toggle(true);
                            logoSeparator.toggle(true);
                            logoContained.toggle(true);
                            break;

                        default:
                            break;
                    }

                });
            });

            wp.customize('clp_background-overlay-enable', function (value) {
                value.bind(function (to) {
                    var overlayColor = wp.customize.control('clp_background-overlay-color');
                    if (to) {
                        overlayColor.toggle(true);
                    } else {
                        overlayColor.toggle(false);
                    }

                });
            });

            wp.customize('clp_form-borders', function (value) {
                value.bind(function (to) {
                    var borderWidth = wp.customize.control('clp_form-border_width'),
                        borderColor = wp.customize.control('clp_form-border_color');

                    if (to) {
                        borderWidth.toggle(true);
                        borderColor.toggle(true);
                    } else {
                        borderWidth.toggle(false);
                        borderColor.toggle(false);
                    }

                });
            });

            wp.customize('clp_form-shadow', function (value) {
                value.bind(function (to) {
                    var horLen = wp.customize.control('clp_form-shadow-horizontal_length'),
                        verLen = wp.customize.control('clp_form-shadow-vertical_length'),
                        blurRad = wp.customize.control('clp_form-shadow-blur_radius'),
                        spreadRad = wp.customize.control('clp_form-shadow-spread_radius'),
                        color = wp.customize.control('clp_form-shadow-color');

                    if (to) {
                        horLen.toggle(true);
                        verLen.toggle(true);
                        blurRad.toggle(true);
                        spreadRad.toggle(true);
                        color.toggle(true);
                    } else {
                        horLen.toggle(false);
                        verLen.toggle(false);
                        blurRad.toggle(false);
                        spreadRad.toggle(false);
                        color.toggle(false);
                    }

                });
            });

            wp.customize('clp_form_footer-display_forgetpassword', function (value) {
                value.bind(function (to) {
                    var forgetPassText = wp.customize.control('clp_form_footer-forgetpassword_text');
                    var forgetPassColor = wp.customize.control('clp_form_footer-forgetpassword_color');
                    var forgetPassColorHover = wp.customize.control('clp_form_footer-forgetpassword_color_hover');
                    var forgetPassText = wp.customize.control('clp_form_footer-forgetpassword_text');
                    var logInText = wp.customize.control('clp_form_footer-login_text');
                    if (to) {
                        forgetPassText.toggle(true);
                        logInText.toggle(true);
                        forgetPassColor.toggle(true);
                        forgetPassColorHover.toggle(true);
                    } else {
                        forgetPassText.toggle(false);
                        logInText.toggle(false);
                        forgetPassColor.toggle(false);
                        forgetPassColorHover.toggle(false);
                    }

                });
            });

            wp.customize('clp_form_footer-display_backtoblog', function (value) {
                value.bind(function (to) {
                    var backToSiteText = wp.customize.control('clp_form_footer-backtoblog_text');
                    var backToSiteColor = wp.customize.control('clp_form_footer-backtoblog_color');
                    var backToSiteColorHover = wp.customize.control('clp_form_footer-backtoblog_color_hover');
                    if (to) {
                        backToSiteText.toggle(true);
                        backToSiteColor.toggle(true);
                        backToSiteColorHover.toggle(true);
                    } else {
                        backToSiteText.toggle(false);
                        backToSiteColor.toggle(false);
                        backToSiteColorHover.toggle(false);
                    }

                });
            });
            wp.customize('clp_form_footer-display_register', function (value) {
                value.bind(function (to) {
                    var registerText = wp.customize.control('clp_form_footer-register_text');
                    var registerColor = wp.customize.control('clp_form_footer-register_color');
                    var registerColorHover = wp.customize.control('clp_form_footer-register_color_hover');
                    var registerSeparator = wp.customize.control('clp_form_footer-login_link_separator');
                    if (to) {
                        registerText.toggle(true);
                        registerColor.toggle(true);
                        registerColorHover.toggle(true);
                        registerSeparator.toggle(true);
                    } else {
                        registerText.toggle(false);
                        registerColor.toggle(false);
                        registerColorHover.toggle(false);
                        registerSeparator.toggle(false);
                    }

                });
            });

            wp.customize('clp_inputs-remember', function (value) {
                value.bind(function (to) {
                    var rememberMe = wp.customize.control('clp_inputs-remember_text');
                    if (to) {
                        rememberMe.toggle(true);
                    } else {
                        rememberMe.toggle(false);
                    }

                });
            });
            wp.customize('clp_background-pattern', function (value) {
                value.bind(function (to) {
                    var customPattern = wp.customize.control('clp_background-pattern-custom');
                    if (to === 'custom') {
                        customPattern.toggle(true);
                    } else {
                        customPattern.toggle(false);
                    }

                });
            });
        });
    }
})(jQuery);

